from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, Boolean, File, String

Eqtlbma_Hm_V0_1_0 = CommandToolBuilder(tool="eqtlbma_hm", base_command=["eqtlbma_hm"], inputs=[ToolInput(tag="in_verbose", input_type=Int(optional=True), prefix="--verbose", doc=InputDocumentation(doc="level (0/default=1/2/3)")), ToolInput(tag="in_data", input_type=Boolean(optional=True), prefix="--data", doc=InputDocumentation(doc="input data (usually output files from eqtlbma_bf)")), ToolInput(tag="in_n_sub_grp", input_type=Int(optional=True), prefix="--nsubgrp", doc=InputDocumentation(doc="of subgroups")), ToolInput(tag="in_model", input_type=Boolean(optional=True), prefix="--model", doc=InputDocumentation(doc="which model to fit (default=configs/types)")), ToolInput(tag="in_dim", input_type=Boolean(optional=True), prefix="--dim", doc=InputDocumentation(doc="dimension of the model (nb of active configs or types)")), ToolInput(tag="in_n_grid", input_type=Boolean(optional=True), prefix="--ngrid", doc=InputDocumentation(doc="number of grid points")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="--out", doc=InputDocumentation(doc="output file (gzipped)")), ToolInput(tag="in_in_it", input_type=Boolean(optional=True), prefix="--init", doc=InputDocumentation(doc="file for initialization\n3 columns: param<tab>value<tab>fixed (TRUE or FALSE)")), ToolInput(tag="in_rand", input_type=Boolean(optional=True), prefix="--rand", doc=InputDocumentation(doc="random initialization")), ToolInput(tag="in_seed", input_type=Boolean(optional=True), prefix="--seed", doc=InputDocumentation(doc="seed used with --rand, otherwise use time")), ToolInput(tag="in_thresh", input_type=Boolean(optional=True), prefix="--thresh", doc=InputDocumentation(doc="threshold to stop the EM (default=0.05)")), ToolInput(tag="in_max_it", input_type=Boolean(optional=True), prefix="--maxit", doc=InputDocumentation(doc="maximum number of iterations (optional)\nuseful if wall-time limit (see also --init)")), ToolInput(tag="in_msl", input_type=Boolean(optional=True), prefix="--msl", doc=InputDocumentation(doc="maximum step length for SQUAREM\ndefault=1 (meaning classical EM), around 3 is a good option")), ToolInput(tag="in_thread", input_type=Boolean(optional=True), prefix="--thread", doc=InputDocumentation(doc="number of threads (default=1)")), ToolInput(tag="in_configs", input_type=Int(optional=True), prefix="--configs", doc=InputDocumentation(doc="of configurations to keep (e.g. '1|3|1-3')")), ToolInput(tag="in_keep_gen", input_type=String(optional=True), prefix="--keepgen", doc=InputDocumentation(doc="'general' ABFs (useful for BMAlite)")), ToolInput(tag="in_get_ci", input_type=Boolean(optional=True), prefix="--getci", doc=InputDocumentation(doc="compute the confidence intervals (single thread, thus slow)")), ToolInput(tag="in_get_bf", input_type=Boolean(optional=True), prefix="--getbf", doc=InputDocumentation(doc="compute the Bayes Factors using the estimated weights\ncan take some time, otherwise only the estimated weights are reported")), ToolInput(tag="in_pi_zero", input_type=Boolean(optional=True), prefix="--pi0", doc=InputDocumentation(doc="fixed value for pi0 (pi0 hence won't be updated in the EM)")), ToolInput(tag="in_ci", input_type=Boolean(optional=True), prefix="--ci", doc=InputDocumentation(doc="file with estimates of hyperparameters to only compute confidence intervals"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="output file (gzipped)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Eqtlbma_Hm_V0_1_0().translate("wdl", allow_empty_container=True)

